%%=========================================================================
%   Code for clustered multitask diffusion LMS    
%           --- Application of target localization  
%
% Reference paper:
%  J. Chen, C. Richard and A. H. Sayed,
%  Multitask diffusion LMS over network. 
%  IEEE ICASSP, 2014.
%
%  Contact:   Dr.Jie.Chen@ieee.org
%             http://www.jie-chen.com
%



clear

% circle center
O = [0, 0]';

% targets positions
% ws =  [-1, -0.95, -1.03 -0.95
%        -1, -0.98   -1.   -1.03];
   
%ws =  [-1, -0.92, -1.06 -0.93
 %      -1, -0.95   -1.   -1.06];

ws =  [-1, -0.90, -1.1 -0.9
       -1, -0.95   -1.   -1.1];


h=figure, hold on
plot(ws(1,1),ws(2,1),'dr', 'markersize', 14, 'linewidth',4)
plot(ws(1,2),ws(2,2),'dg', 'markersize', 14, 'linewidth',4)
plot(ws(1,3),ws(2,3),'dm', 'markersize', 14, 'linewidth',4)
plot(ws(1,4),ws(2,4),'dk', 'markersize', 14, 'linewidth',4)


[L,Nc] = size(ws);

% sensors   
N = 120;
% sensor region defintion
% center
sc = [0,-20];
% width
sw = 2;
% length
sl = 1;
% rotation
stheta = pi/4;
% canonic form
x1 = sw*(rand(N,1)-0.5)+sc(1);
y1 = sl*(rand(N,1)-0.5)+sc(2);
% rotated
% X = [x1,y1]*[cos(stheta) sin(stheta); -sin(stheta), cos(stheta)];
% 
% figure, hold on
% plot(X(1:30,1),X(1:30,2),'or','markersize',8,'linewidth',3)
% plot(X(31:60,1),X(31:60,2),'og','markersize',8,'linewidth',3)
% plot(X(61:90,1),X(61:90,2),'om','markersize',8,'linewidth',3)
% plot(X(91:120,1),X(91:120,2),'ok','markersize',8,'linewidth',3)
% 
 ClsMask = kron(eye(4),ones(30,30));
% %ClsMask = eye(120); 
% 
%  D = dist(X');
% % 
%  dth = 0.18;
% % 
%  ConnectionMatrix = zeros(size(D));
%  ConnectionMatrix(D < dth) =1;
% % 
% for i = 1 : size(X,1)
%     for j =  i+1 : size(X,1)
%         if ConnectionMatrix(i,j)
%             plot([X(i,1), X(j,1)], [X(i,2), X(j,2)],'color',[0.5,0.5,0.5])
%         end
%     end
% end
% 
% X=X';

load config2


tic

% direction pointing vectors distances to associated with target
for i = 1 : 4
    idx = (i-1)*30+1:i*30;
    uos = ws(:,i)*ones(1,30)-X(:,idx);
    rr(idx) = sqrt(sum(uos.^2));
    uo(:,idx) = uos*diag(1./rr(idx));
end

%ClsMask = eye(N);

A = eye(N);
A = diag(1./sum(ConnectionMatrix.*ClsMask))*(ConnectionMatrix.*ClsMask);
%P = diag(sum(ConnectionMatrix.*(1-ClsMask),2))+ConnectionMatrix.*(1-ClsMask);

P = ConnectionMatrix.*(1-ClsMask);;
idx = (sum(P,2)>0);
P(idx,:) = diag(1./sum(P(idx,:),2))*P(idx,:);

%P = diag(1./sum(P,2))*P;
lambda = 0.05;

L = 2;

u  = zeros(size(uo));


W = zeros(L,N);
W2 = W;
W3 = W;
U = W;
T = 3000;
mu = 0.3;
Ru = 0;
pud=0;
ur = 0;
uu=0;


wc = kron(ws,ones(1,30));
for t = 1 : T
   %-- Data generation --
   for n = 1 : N
      u(:,n) = uo(:,n) + 0.001*randn*uo(:,n) + 0.1*randn*[uo(2,n),-uo(1,n)]';
      rn(n) = rr(n) + 0.3*randn;    
      d(n) = rn(n) + X(:,n)'*u(:,n) ;
   end
   
   
   
   %-- Non-cooperative LMS --
   for n = 1 : N

      e(n) = d(n) - W(:,n)'*u(:,n); 
      W(:,n) = W(:,n) + mu * e(n) * u(:,n);%/sqrt(u(:,n)'*u(:,n)) ;
%        e1= rn(n)*u(1,n) + X(1,n)-W(1,n);
%        W(1,n) = W(1,n) + mu * e1;
%        e2= rn(n)*u(2,n) + X(2,n)-W(2,n);
%        W(2,n) = W(2,n) + mu * e2;
       
%       e = rn(n)*u(:,n)+X(:,n)-W(:,n);
%       W(:,n) = W(:,n) + mu * e  ;
     %    W(1,n) = (W(1,n)*(t-1) + rn(n)*u(1,n) + X(1,n))/t;
     %    W(2,n) = (W(2,n)*(t-1) + rn(n)*u(2,n) + X(2,n))/t;
   
   end



   %clustered diffusion regularized
   
  for n = 1 : N
      idx = find(P(n,:)~=0);
         if length(idx) >=1
            regterms =  W2(:,n)*ones(1,length(idx))-W2(:,idx);
            weightP = (P(n,idx)+P(idx,n)')/2;
            regterm = sum(regterms*diag(weightP),2);
         else
            regterm =0;
         end
   
      e2(n) = d(n) - W2(:,n)'*u(:,n); 
      U(:,n) = W2(:,n) + mu * e2(n) * u(:,n) -  mu*lambda*regterm;%/sqrt(u(:,n)'*u(:,n)) ;
   
  end
  
        for n = 1 : N
            idx = (A(n,:)>0);
             W2((n-1)*L+1:n*L) = sum(U(:,idx)*diag(A(n,idx)),2);
        end
        
%    %     clustered diffusion non-regularized
%   for n = 1 : N
%    
%       e3(n) = d(n) - W3(:,n)'*u(:,n); 
%       U(:,n) = W3(:,n) + mu * e3(n) * u(:,n);%/sqrt(u(:,n)'*u(:,n)) ;
%    
%   end
%        for n = 1 : N
%            W3((n-1)*L+1:n*L) = sum(reshape(U,L,[])*diag(A(n,:)),2);
%        end
%        
     err(t) = norm(W-wc,'fro').^2;
     err2(t) = norm(W2-wc,'fro').^2;
 %     err3(t) = norm(W3-wc,'fro');
end

toc

figure(h)



plot(W(1,1:30),W(2,1:30),'rx','markersize',9)
plot(W(1,31:60),W(2,31:60),'gx','markersize',9)
plot(W(1,61:90),W(2,61:90),'mx','markersize',9)
plot(W(1,91:120),W(2,91:120),'kx','markersize',9)
norm(W-wc,'fro')


 W2 = reshape(W2,L,[]);
 plot(W2(1,1:30),W2(2,1:30),'ro','markersize',9)
 plot(W2(1,31:60),W2(2,31:60),'go','markersize',9)
 plot(W2(1,61:90),W2(2,61:90),'mo','markersize',9)
 plot(W2(1,91:120),W2(2,91:120),'ko','markersize',9)


norm(W2-wc,'fro')
norm(W3-wc,'fro')

%plot(W3(1:N,1),W3(1:N,2),'kd', 'markersize',5)

%norm(W3-wc,'fro')

xlabel('$X$','fontsize',14,'interpreter', 'latex')
ylabel('$Y$','fontsize',14,'interpreter', 'latex')

figure, plot(10*log10(err/N)), hold on, 
plot(10*log10(err2/N),'r'), 
%plot(10*log10(err3/N),'g')
